// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige2.core.dao.sandre;

import fr.ifremer.quadrige2.core.dao.referential.taxon.ReferenceTaxon;
import java.io.Serializable;

/**
 * Taxons sandre pour les exports de données
 */
// HibernateEntity.vsl annotations merge-point
public abstract class SandreTaxonExp
    implements Serializable, Comparable<SandreTaxonExp>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -227507560601403433L;

    // Generate 3 attributes
    private Integer sandreTaxonId;

    /**
     * Identifiant interne du taxon sandre
     * @return this.sandreTaxonId Integer
     */
    public Integer getSandreTaxonId()
    {
        return this.sandreTaxonId;
    }

    /**
     * Identifiant interne du taxon sandre
     * @param sandreTaxonIdIn Integer
     */
    public void setSandreTaxonId(Integer sandreTaxonIdIn)
    {
        this.sandreTaxonId = sandreTaxonIdIn;
    }

    private String sandreTaxonLb;

    /**
     * Libellé du taxon sandre
     * @return this.sandreTaxonLb String
     */
    public String getSandreTaxonLb()
    {
        return this.sandreTaxonLb;
    }

    /**
     * Libellé du taxon sandre
     * @param sandreTaxonLbIn String
     */
    public void setSandreTaxonLb(String sandreTaxonLbIn)
    {
        this.sandreTaxonLb = sandreTaxonLbIn;
    }

    private Integer sandreTaxonExpId;

    /**
     * 
     * @return this.sandreTaxonExpId Integer
     */
    public Integer getSandreTaxonExpId()
    {
        return this.sandreTaxonExpId;
    }

    /**
     * 
     * @param sandreTaxonExpIdIn Integer
     */
    public void setSandreTaxonExpId(Integer sandreTaxonExpIdIn)
    {
        this.sandreTaxonExpId = sandreTaxonExpIdIn;
    }

    // Generate 1 associations
    private ReferenceTaxon refTaxonId;

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @return this.refTaxonId ReferenceTaxon
     */
    public ReferenceTaxon getRefTaxonId()
    {
        return this.refTaxonId;
    }

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @param refTaxonIdIn ReferenceTaxon
     */
    public void setRefTaxonId(ReferenceTaxon refTaxonIdIn)
    {
        this.refTaxonId = refTaxonIdIn;
    }

    /**
     * Returns <code>true</code> if the argument is an SandreTaxonExp instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof SandreTaxonExp))
        {
            return false;
        }
        final SandreTaxonExp that = (SandreTaxonExp)object;
        if (this.sandreTaxonExpId == null || that.getSandreTaxonExpId() == null || !this.sandreTaxonExpId.equals(that.getSandreTaxonExpId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.sandreTaxonExpId == null ? 0 : this.sandreTaxonExpId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link SandreTaxonExp}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link SandreTaxonExp}.
         * @return new SandreTaxonExpImpl()
         */
        public static SandreTaxonExp newInstance()
        {
            return new SandreTaxonExpImpl();
        }

        /**
         * Constructs a new instance of {@link SandreTaxonExp}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param sandreTaxonId Integer
         * @param refTaxonId ReferenceTaxon
         * @return newInstance
         */
        public static SandreTaxonExp newInstance(Integer sandreTaxonId, ReferenceTaxon refTaxonId)
        {
            final SandreTaxonExp entity = new SandreTaxonExpImpl();
            entity.setSandreTaxonId(sandreTaxonId);
            entity.setRefTaxonId(refTaxonId);
            return entity;
        }

        /**
         * Constructs a new instance of {@link SandreTaxonExp}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param sandreTaxonId Integer
         * @param sandreTaxonLb String
         * @param refTaxonId ReferenceTaxon
         * @return newInstance SandreTaxonExp
         */
        public static SandreTaxonExp newInstance(Integer sandreTaxonId, String sandreTaxonLb, ReferenceTaxon refTaxonId)
        {
            final SandreTaxonExp entity = new SandreTaxonExpImpl();
            entity.setSandreTaxonId(sandreTaxonId);
            entity.setSandreTaxonLb(sandreTaxonLb);
            entity.setRefTaxonId(refTaxonId);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(SandreTaxonExp o)
    {
        int cmp = 0;
        if (this.getSandreTaxonExpId() != null)
        {
            cmp = this.getSandreTaxonExpId().compareTo(o.getSandreTaxonExpId());
        }
        else
        {
            if (this.getSandreTaxonId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSandreTaxonId().compareTo(o.getSandreTaxonId()));
            }
            if (this.getSandreTaxonLb() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getSandreTaxonLb().compareTo(o.getSandreTaxonLb()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// SandreTaxonExp.java merge-point
}